Ext.define("P5Jobmanager.view.ScheduledJobsGrid", {
    extend: 'Ext.grid.Panel',
    alias: "widget.scheduledjobsgrid",

    stateful: true,
    stateId:   'stateScheduledjobsgrid_id',
    reference: 'scheduledjobsgrid_ref',
    itemId:    'scheduledjobsgrid_id',

    bind:{
        store: '{scheduledqueuestore}',
        hidden: '{isParkedJobsQueuesChecked}'
    },

    applyState: function(state) {
        // disable stateful sorters and filters
        // ist a workaround for stateful "getViewModel() is null"
        state.sort = false;
        state.storeState = false;
        this.callParent(arguments);
    },

    viewConfig: {
        loadMask: false,
        preserveScrollOnReload: true,
        preserveScrollOnRefresh: true
    },

    border: false,
    flex: 1,

    selModel: {
        selType: 'checkboxmodel',
        injectCheckbox: 0
    },

    columns: [{
        dataIndex: 'jtype',
        align: 'center',
        text: '',
        menuDisabled : true,
        width: 32,
        renderer: function(value,metaData,record) {
            switch(value) {
                case 'archivejob':
                    metaData.tdCls = 'archivejob-icon';
                    break;
                case 'backupjob':
                    metaData.tdCls = 'backupjob-icon';
                    break;
                case 'backup2gojob':
                    metaData.tdCls = 'backup2gojob-icon';
                    break;
                case 'syncjob':
                    metaData.tdCls = 'syncjob-icon';
                    break;
                case 'migrationjob':
                    metaData.tdCls = 'migrationjob-icon';
                    break;
                case 'restorejob':
                    metaData.tdCls = 'restorejob-icon';
                    break;
                default:
                    metaData.tdCls = 'otherjob-icon';
            }
        }
    },{ text: $$('Scheduled by Time'), dataIndex: 'text', width: 200
    },{ text: $$('Client'), dataIndex: 'client', width: 80
    },{ text: $$('User'), dataIndex: 'owner', width: 80
    },{ text: $$('Level'), dataIndex: 'level', width: 60
    },{ text: $$('Pool'), dataIndex: 'pool', width: 80
    },{ 
        text: $$('Start Time'),
        dataIndex: 'start',
        width: 90,
        xtype: 'datecolumn',
        format: Ext.Date.patterns['formatTimeShort']
    },{
        text: $$('Job'),
        dataIndex: 'jobid',
        flex: 1
    }],
    dockedItems: [{
        xtype: 'toolbar',
        dock: 'bottom',
        layout: { pack: 'left' },
        items: [{
            xtype: 'button',
            iconCls: 'fa fa-play inbutton',
            text: $$('Start'),
            handler: 'onStartNow'
        },{
            xtype: 'button',
            iconCls: 'fa fa-trash inbutton',
            text: $$('Remove'),
            handler: 'onStopRemove'
        }]
    }]
});